Type ETE_Mesh
	Field StaticShadow
	Field SSenabled
	Field ent
	Field SHWVolumeSurf
	Field SHWVolumeCapSurf
	Field cnt_vert, vert.ETE_Vertex[ETE_MaxTriang]
	Field cnt_tris, tri.ETE_Triangle[ETE_MaxTriang]
End Type

Type ETE_Vertex
	;Non modificare da qu
	;Field ID_Vert%
	Field x#, y#, z#
	Field tf_x#, tf_y#, tf_z#
	Field ray_x#,ray_y#,ray_z#
	Field ID_Succ.ETE_Vertex
End Type



Type ETE_Triangle
	Field Id_v1, Id_v2, Id_v3
	Field v1.ETE_Vertex
	Field v2.ETE_Vertex
	Field v3.ETE_Vertex
	Field nx#, ny#, nz#, cull
	Field ta, tb, tc
	Field id_ta.ETE_Triangle, id_tb.ETE_Triangle, id_tc.ETE_Triangle
	Field ID_Succ.ETE_Triangle
End Type
Const ETE_MaxTriang = 65535, SHWCacheVersion$ = "shw_1.57u", VolumeLenght = 65535, Over1_3# = 1.0/3.0

Global VolumeMesh, VolumeCap

Function InitVolumes()
	VolumeMesh = CreateMesh()
	;VolumeSurf = CreateSurface(VolumeMesh)
	EntityColor VolumeMesh, 255, 0, 0
	EntityAlpha VolumeMesh, .5
	VolumeCap = CreateMesh()
	;VolumeCapSurf = CreateSurface(VolumeCap)
	EntityAlpha VolumeCap, .5
End Function

Function FreeVolumes()
Delete Each ETE_Mesh
Delete Each ETE_Triangle
If VolumeMesh Then FreeEntity VolumeMesh
If VolumeCap Then FreeEntity VolumeCap
End Function

Function InitVolumeCaster.ETE_Mesh(ent)
	;===>
	Local etem.ETE_Mesh = New ETE_Mesh
	etem\ent = ent
	etem\SHWVolumeSurf = CreateSurface(VolumeMesh)
	etem\SHWVolumeCapSurf = CreateSurface(VolumeCap)
	;===>
	Local cnt_surf = CountSurfaces(etem\ent)
	Local cnt = -1
	Local id
	;===>
	Local AddVert = 0
	Local AddTris = 0
	etem\cnt_vert = 0
	etem\cnt_tris = 0
	;===>
	For s = 1 To cnt_surf
		Local surf = GetSurface(ent, s)
		;===>
		; Load Vertex in memory
		Local NVert = CountVertices(surf)
		etem\cnt_vert = etem\cnt_vert + NVert
		;===>
		For v = 0 To (NVert - 1)
			;===>
			id = v+AddVert
			etem\vert[id] = New ETE_Vertex
			Local vert.ETE_Vertex = etem\vert[id]
			;===>
			vert\x# = VertexX(surf, v)
			vert\y# = VertexY(surf, v)
			vert\z# = VertexZ(surf, v)
			;===>
		Next
		;===>
		; Load Triangle in memory
		;===>
		Local NTris = CountTriangles(surf)
		etem\cnt_tris = etem\cnt_tris + NTris 
		;===>
		For v = 0 To NTris-1
			id = v+AddTris
			etem\tri[id] = New ETE_Triangle
			Local etet.ETE_Triangle = etem\tri[id]
			etet\Id_v1 = TriangleVertex(surf, v, 0)+AddVert
			etet\Id_v2 = TriangleVertex(surf, v, 1)+AddVert
			etet\Id_v3 = TriangleVertex(surf, v, 2)+AddVert
			etet\ta = -1
			etet\tb = -1
			etet\tc = -1
			;===>
;			;Debug
;			If (id=4786) Then 
;				If(etet\Id_v1 > etem\cnt_vert) Then Stop
;				If(etet\Id_v2 > etem\cnt_vert) Then Stop
;				If(etet\Id_v3 > etem\cnt_vert) Then Stop
;			EndIf	
;			;===>
;			If (etem\vert[etet\Id_v1]=Null) Then Stop
;			If (etem\vert[etet\Id_v2]=Null) Then Stop
;			If (etem\vert[etet\Id_v3]=Null) Then Stop
			;===>
		Next
		AddVert = AddVert + NVert
		AddTris = AddTris + NTris
	Next 
	
	;etem\cnt_vert = etem\cnt_vert - 1 ;
	;etem\cnt_tris = etem\cnt_tris - 1 ;
	;Return etem
	
	;===>
	; Test adiacent face
	;===>
	cnt_tris = etem\cnt_tris
	For a = 0 To cnt_tris - 1
		;===>
		Local at.ETE_Triangle = etem\tri[a]
		;===>
		For b = a + 1 To cnt_tris - 1
			;===>
			Local bt.ETE_Triangle = etem\tri[b]
			;===>
			v1a_v2a = (at\Id_v1 = bt\Id_v1)
			v1a_v2b = (at\Id_v1 = bt\Id_v2)
			v1a_v2c = (at\Id_v1 = bt\Id_v3)
			v1b_v2a = (at\Id_v2 = bt\Id_v1)
			v1b_v2b = (at\Id_v2 = bt\Id_v2)
			v1b_v2c = (at\Id_v2 = bt\Id_v3)
			v1c_v2a = (at\Id_v3 = bt\Id_v1)
			v1c_v2b = (at\Id_v3 = bt\Id_v2)
			v1c_v2c = (at\Id_v3 = bt\Id_v3)
			;===>
			If v1a_v2b And v1b_v2a Then
				at\ta = b
				bt\ta = a
			ElseIf v1b_v2b And v1c_v2a Then
				at\tb = b
				bt\ta = a
			ElseIf v1c_v2b And v1a_v2a Then
				at\tc = b
				bt\ta = a
			ElseIf v1a_v2c And v1b_v2b Then
				at\ta = b
				bt\tb = a
			ElseIf v1b_v2c And v1c_v2b Then
				at\tb = b
				bt\tb = a
			ElseIf v1c_v2c And v1a_v2b Then
				at\tc = b
				bt\tb = a
			ElseIf v1a_v2a And v1b_v2c Then
				at\ta = b
				bt\tc = a
			ElseIf v1b_v2a And v1c_v2c Then
				at\tb = b
				bt\tc = a
			ElseIf v1c_v2a And v1a_v2c Then
				at\tc = b
				bt\tc = a
			EndIf
		Next
	Next
	;===>
	InitETEM(etem)
	;===>
	Return etem
End Function

Function LoadVolumeCaster.ShadowMesh(ent, path$, file = -1)
	If file = -1 Then
		file = ReadFile(path$)
		If ReadString(file) <> SHWCacheVersion$ Then
			CloseFile file
			DeleteFile path$
			RecursiveShadowCaster(ent, path$)
			Return
		EndIf
	EndIf
	Local sm.ShadowMesh = New ShadowMesh
	sm\ent = ent
	sm\casting = True
	Local etem.ETE_Mesh = New ETE_Mesh
	etem\SHWVolumeSurf = CreateSurface(VolumeMesh)
	etem\SHWVolumeCapSurf = CreateSurface(VolumeCap)
	;===>
	etem\ent = sm\ent
	;===>
	etem\cnt_vert = ReadInt(file)
	;===>
	For v = 0 To etem\cnt_vert-1
		;===>
		etem\vert[v] = New ETE_Vertex
		Local vert.ETE_Vertex = etem\vert[v]
		vert\x = ReadFloat(file)
		vert\y = ReadFloat(file)
		vert\z = ReadFloat(file)
		;===>
	Next
	
	;===>
	etem\cnt_tris = ReadInt(file)
	;===>
	For v = 0 To etem\cnt_tris-1
		;===>
		etem\tri[v] = New ETE_Triangle
		Local etet.ETE_Triangle = etem\tri[v]
		etet\Id_v1 = ReadInt(file)
		etet\Id_v2 = ReadInt(file)
		etet\Id_v3 = ReadInt(file)
		etet\ta = ReadInt(file) - 1
		etet\tb = ReadInt(file) - 1
		etet\tc = ReadInt(file) - 1
		;===>
	Next
	;===>
	InitETEM(etem)
	cnt_children = CountChildren(ent)
	For i = 1 To cnt_children
		LoadVolumeCaster(GetChild(ent, i), "", file)
	Next
End Function

Function InitETEM(etem.ETE_Mesh)
	;===>
	;===>
	For v = 0 To etem\cnt_vert-1
		;===>
		If v<etem\cnt_vert Then 
			etem\vert[v]\ID_Succ	= etem\vert[v+1] 
		Else 
			etem\vert[v]\ID_Succ	= Null
		EndIf
		
	Next
	
	;===>
	For v = 0 To etem\cnt_tris-1
		;===>
		Local etet.ETE_Triangle = etem\tri[v]
		;===>
		etet\v1 = etem\vert[etet\Id_v1]
		etet\v2 = etem\vert[etet\Id_v2]
		etet\v3 = etem\vert[etet\Id_v3]
		;===>
		If etet\ta > -1 Then etet\id_ta = etem\tri[etet\ta]
		If etet\tb > -1 Then etet\id_tb = etem\tri[etet\tb]
		If etet\tc > -1 Then etet\id_tc = etem\tri[etet\tc]
		;===>
		If v<etem\cnt_tris Then 
			etet\ID_Succ	= etem\tri[v+1] 
		Else 
			etet\ID_Succ	= Null
		EndIf
		
	Next
End Function
Function SetStaticShadow(Obj, Flag=False)
	For etem.ETE_Mesh = Each ETE_Mesh
		;===>
		If Obj=etem\ent Then 
			etem\StaticShadow = Flag
			etem\SSenabled = False
		EndIf
	Next 
End Function

Function UpdateStaticShadow(Obj, Flag=False)
	SetStaticShadow(Obj)
End Function


Function UpdateVolumesVertex(cnt_vert,vert.ETE_Vertex,CurObj,sl.ShadowLight)
	Local Parallel = sl\parallel
	;===>
	Local light_x# = EntityX(sl\ent, True) * (1 + Parallel * 1000000)
	Local light_y# = EntityY(sl\ent, True) * (1 + Parallel * 1000000)
	Local light_z# = EntityZ(sl\ent, True) * (1 + Parallel * 1000000)
	;===>
	For v = 0 To cnt_vert-1
		;===>
		TFormPoint vert\x#, vert\y#, vert\z#, CurObj, 0
		vert\tf_x# = TFormedX()
		vert\tf_y# = TFormedY()
		vert\tf_z# = TFormedZ()
		;===>
		vert\ray_x = vert\tf_x + (vert\tf_x# - light_x#) * VolumeLenght
		vert\ray_y = vert\tf_y + (vert\tf_y# - light_y#) * VolumeLenght
		vert\ray_z = vert\tf_z + (vert\tf_z# - light_z#) * VolumeLenght
		;===>
		vert = vert\ID_Succ
	Next
	
End Function

Function UpdateVolumesTriangle(cnt_tris,etet.ETE_Triangle,CurObj,sl.ShadowLight)
	Local Parallel = sl\parallel
	;===>
	Local light_x# = EntityX(sl\ent, True) * (1 + Parallel * 1000000)
	Local light_y# = EntityY(sl\ent, True) * (1 + Parallel * 1000000)
	Local light_z# = EntityZ(sl\ent, True) * (1 + Parallel * 1000000)
	;===>
	Local v1.ETE_Vertex
	Local v2.ETE_Vertex
	Local v3.ETE_Vertex
	For v = 0 To cnt_tris-1
				;===>
		Local v1x# = etet\v1\tf_x : Local v1y# = etet\v1\tf_y : Local v1z# = etet\v1\tf_z
				;===>
		Local v2x# = etet\v2\tf_x : Local v2y# = etet\v2\tf_y : Local v2z# = etet\v2\tf_z
				;===>
		Local v3x# = etet\v3\tf_x : Local v3y# = etet\v3\tf_y : Local v3z# = etet\v3\tf_z
				;===>
		Local e0x# = v3x# - v2x# : Local e0y# = v3y# - v2y# : Local e0z# = v3z# - v2z#
		Local e1x# = v2x# - v1x# : Local e1y# = v2y# - v1y# : Local e1z# = v2z# - v1z#
				;===>
		Local normlight_x# = (((v1x# + v2x# + v3x#)*Over1_3)- light_x#)* (e0y# * e1z# - e0z# * e1y#)
		Local normlight_y# = (((v1y# + v2y# + v3y#)*Over1_3)- light_y#)* (e0z# * e1x# - e0x# * e1z#)
		Local normlight_z# = (((v1z# + v2z# + v3z#)*Over1_3)- light_z#)* (e0x# * e1y# - e0y# * e1x#)
				;===>
		etet\cull = (normlight_x# + normlight_y# + normlight_z# > 0)
		etet = etet\ID_Succ
				;===>
	Next
	
End Function

Function UpdateVolumes(sl.ShadowLight, top_caps = True)
	Local Parallel = sl\parallel
	
	Local light_x# = EntityX(sl\ent, True) * (1 + Parallel * 1000000)
	Local light_y# = EntityY(sl\ent, True) * (1 + Parallel * 1000000)
	Local light_z# = EntityZ(sl\ent, True) * (1 + Parallel * 1000000)
	Local etem.ETE_Mesh
	;===>
	Local v1.ETE_Vertex
	Local v2.ETE_Vertex
	Local v3.ETE_Vertex
	
	For etem.ETE_Mesh = Each ETE_Mesh
		If sl\range# = -1 Or EntityDistance(sl\ent, etem\ent) < sl\range# Then
		;===>
		If (etem\StaticShadow = True) And (etem\SSenabled = True ) Then
			Goto JumpCalc
		EndIf
		;===>
			Local cnt_vert = etem\cnt_vert
			Local cnt_tris = etem\cnt_tris
			
			Local CurObj = etem\ent
			;===>
			UpdateVolumesVertex(cnt_vert,etem\vert[0],CurObj,sl)
			UpdateVolumesTriangle(cnt_tris,etem\tri[0],CurObj,sl)
			;===>
			Local vert1,vert2,vert3,vert4;
			ClearSurface etem\SHWVolumeSurf
			ClearSurface etem\SHWVolumeCapSurf
			;===>
			Local SHWVolumeSurf = etem\SHWVolumeSurf
			Local SHWVolumeCapSurf = etem\SHWVolumeSurf
			;===>
			Local etet.ETE_Triangle = etem\tri[0]
			For v = 0 To cnt_tris-1
				;===>
				v1.ETE_Vertex = etet\v1
				v2.ETE_Vertex = etet\v2
				v3.ETE_Vertex = etet\v3
				;===>
				If etet\cull = False Then
					If etet\ta > -1 Then check1 = etet\id_ta\cull Else check1 = True
					If etet\tb > -1 Then check2 = etet\id_tb\cull Else check2 = True
					If etet\tc > -1 Then check3 = etet\id_tc\cull Else check3 = True
					If check1 Then
						vert1 = AddVertex(SHWVolumeSurf, v1\tf_x#,	v1\tf_y#,		v1\tf_z#)
						vert2 = AddVertex(SHWVolumeSurf, v2\tf_x#, 	v2\tf_y#,		v2\tf_z#)
						vert3 = AddVertex(SHWVolumeSurf, v1\ray_x#,	v1\ray_y#,	v1\ray_z#)
						vert4 = AddVertex(SHWVolumeSurf, v2\ray_x#,	v2\ray_y#,	v2\ray_z#)
						AddTriangle SHWVolumeSurf, vert1, vert3, vert4
						AddTriangle SHWVolumeSurf, vert1, vert4, vert2
					EndIf
					If check2 Then
						vert1 = AddVertex(SHWVolumeSurf, v2\tf_x#, 	v2\tf_y#,		v2\tf_z#)
						vert2 = AddVertex(SHWVolumeSurf, v3\tf_x#, 	v3\tf_y#,		v3\tf_z#)
						vert3 = AddVertex(SHWVolumeSurf, v2\ray_x#,	v2\ray_y#,	v2\ray_z#)
						vert4 = AddVertex(SHWVolumeSurf, v3\ray_x#,	v3\ray_y#,	v3\ray_z#)
						AddTriangle SHWVolumeSurf, vert1, vert3, vert4
						AddTriangle SHWVolumeSurf, vert1, vert4, vert2
					EndIf
					If check3 Then
						vert1 = AddVertex(SHWVolumeSurf, v1\tf_x#,	v1\tf_y#,		v1\tf_z#)
						vert2 = AddVertex(SHWVolumeSurf, v3\tf_x#,	v3\tf_y#,		v3\tf_z#)
						vert3 = AddVertex(SHWVolumeSurf, v1\ray_x#,	v1\ray_y#,	v1\ray_z#)
						vert4 = AddVertex(SHWVolumeSurf, v3\ray_x#,	v3\ray_y#,	v3\ray_z#)
						AddTriangle SHWVolumeSurf, vert1, vert4, vert3
						AddTriangle SHWVolumeSurf, vert1, vert2, vert4
					EndIf
					If top_caps Then
						vert1 = AddVertex(SHWVolumeCapSurf, v1\tf_x#, v1\tf_y#, v1\tf_z#)
						vert2 = AddVertex(SHWVolumeCapSurf, v2\tf_x#, v2\tf_y#, v2\tf_z#)
						vert3 = AddVertex(SHWVolumeCapSurf, v3\tf_x#, v3\tf_y#, v3\tf_z#)
						AddTriangle SHWVolumeCapSurf, vert1, vert2, vert3
					EndIf
				ElseIf Parallel = False Then
					vert1 = AddVertex(SHWVolumeSurf, v1\ray_x#, v1\ray_y#, v1\ray_z#)
					vert2 = AddVertex(SHWVolumeSurf, v2\ray_x#, v2\ray_y#, v2\ray_z#)
					vert3 = AddVertex(SHWVolumeSurf, v3\ray_x#, v3\ray_y#, v3\ray_z#)
					AddTriangle SHWVolumeSurf, vert1, vert2, vert3
				EndIf
				etet = etet\ID_Succ
			Next
		;===>
		If (etem\StaticShadow = True) Then etem\SSenabled = True
		;===>
.JumpCalc
		EndIf
	Next
End Function
;~IDEal Editor Parameters:
;~C#Blitz3D194